#ifndef _TEST_APP
#define _TEST_APP


#include "ofMain.h"
#include "ofxOpenCv.h"
#include "vectorField.h"
#include "particle.h"
#define _USE_LIVE_VIDEO
class testApp : public ofBaseApp{
	
	public:
		
		void setup();
		void update();
		void draw();
		
		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);
		
		void audioReceived 	(float * input, int bufferSize, int nChannels); 
			vector <particle> particles;
		vectorField VF;
		
		float * left;
		float * right;
		int 	bufferCounter;
		int 	drawCounter;
		
		float	volume;


		//cv code
				int		threshold;
		float	prevMouseX;
		float	prevMouseY;
		bool	bDrawDiagnostic;
		bool	bLearnBakground;
		bool	bForceOutward;
		#ifdef _USE_LIVE_VIDEO

			ofVideoGrabber 		vidGrabber; 
			
		#else
			ofVideoPlayer 		vidPlayer;
		#endif


		
		ofxCvColorImage			colorImg;
		ofxCvGrayscaleImage 	grayImage;
		ofxCvGrayscaleImage 	grayBg;
		ofxCvGrayscaleImage 	grayDiff;
		ofxCvGrayscaleImage		grayDiffSmall;
		
};

#endif	

